unit childMoz;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, ComCtrls,
  ToolWin, ImgList, OleCtrls, SHDocVw,main,SysUtils, MOZILLACONTROLLib_TLB;

type
  Tfrm_MZ = class(TForm)
    TWeb_MZ: TMozillaBrowser;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TWeb_IENewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure TWeb_IEStatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TWeb_MZNewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure TWeb_MZProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure TWeb_MZStatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure TWeb_MZTitleChange(Sender: TObject; const Text: WideString);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure TWeb_MZCommandStateChange(Sender: TObject; Command: Integer;
      Enable: WordBool);
    procedure SubChange(Enable:WordBool);
  private
    { Private 錾 }
    strURL: string;
    blBack	: WordBool;
    blFrwrd	: WordBool;
    blStop 	: WordBool;
    blReLoad: WordBool;
    tmpBool: WordBool;
  public
    { Public 錾 }
  end;

implementation

procedure Tfrm_MZ.SubChange(Enable:WordBool);
begin
  //߂Eiނ̏󋵂L
	with MainForm do begin
  	if Enable=True then begin
  		Tfrm_MZ(ActiveMDIChild).blBack:=BackCtrl.Enabled;
  		Tfrm_MZ(ActiveMDIChild).blFrwrd:=FrwrdCtrl.Enabled;
    	Tfrm_MZ(ActiveMDIChild).blReLoad:=ReLoadCtrl.Enabled;
  		Tfrm_MZ(ActiveMDIChild).blStop:=StopCtrl.Enabled;
    end else begin
  		ProgressBar1.Position:=0;
		  txtAddress.Text:='';
		  StatusBar1.Panels.Items[0].Text:='';

		  //c[{^
				BackCtrl.Enabled:=False;
				FrwrdCtrl.Enabled:=False;
				ReLoadCtrl.Enabled:=False;
				StopCtrl.Enabled:=False;
		end;
  end;
end;
{$R *.DFM}

procedure Tfrm_MZ.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //lɖ߂
  tmpBool:=False;
  	//OtĕۑFalse
  		MainForm.mnuFile_SaveAs.Enabled:=False;
  	//ҏWj[False
  		MainForm.mnuEdit_slrAll.Enabled:=False;
    	MainForm.mnuEdit_Copy.Enabled:=False;
  	//TCYFalse
  		MainForm.mnuShow_Size.Enabled:=False;
  //
  Action := caFree;
end;

procedure Tfrm_MZ.TWeb_IENewWindow2(Sender: TObject; var ppDisp: IDispatch; var Cancel: WordBool);
begin
  //炵tH[쐬
  MainForm.CreateMDIChild('test',strURL);
  //irQ[g̃LZ
  Cancel := True;
end;

procedure Tfrm_MZ.TWeb_IEStatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  //}EXǂĂ邩`FbN
  MainForm.StatusBar1.Panels.Items[0].Text:=text;
  strURL:=text;
end;

procedure Tfrm_MZ.FormResize(Sender: TObject);
begin
  //TCY̒`
  TWeb_mz.Width:=Self.Width-10;
  TWeb_mz.Height:=Self.Height-30;
end;

procedure Tfrm_MZ.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  //TCY̒`
  TWeb_mz.Width:=Self.Width-10;
  TWeb_mz.Height:=Self.Height-30;
end;

procedure Tfrm_MZ.FormCreate(Sender: TObject);
begin
  self.OnResize(Sender);
  self.Caption:='Gecko';
  //߂Eiނ̏󋵂L
 	With Main.MainForm do begin
  	blBack:=BackCtrl.Enabled;
  	blFrwrd:=FrwrdCtrl.Enabled;
  	blStop:=StopCtrl.Enabled;
  end;
  tmpBool:=True;
end;

procedure Tfrm_MZ.FormActivate(Sender: TObject);
begin
  //ANeBȕ
  //URL̕ύX
  MainForm.txtAddress.Text:=TWeb_mz.LocationURL;
  //vOXo[̕ύX
  MainForm.ProgressBar1.Position:=self.Tag;
  //TCY̍Ē`
  FormResize(sender);

  With Main.MainForm do begin 
  //߂Eiނ̏󋵂ύX
 	 	BackCtrl.Enabled:=Tfrm_MZ(ActiveMDIChild).blBack;
  	FrwrdCtrl.Enabled:=Tfrm_MZ(ActiveMDIChild).blFrwrd;
  	StopCtrl.Enabled:=Tfrm_MZ(ActiveMDIChild).blStop;
    ReLoadCtrl.Enabled:=Tfrm_MZ(ActiveMDIChild).blReLoad;
  end;
  //OtĕۑTrue
  	MainForm.mnuFile_SaveAs.Enabled:=True;
  //ҏWj[True
  	MainForm.mnuEdit_slrAll.Enabled:=True;
    MainForm.mnuEdit_Copy.Enabled:=True;
  //TCYFalse
  	MainForm.mnuShow_Size.Enabled:=False;
end;

procedure Tfrm_MZ.TWeb_MZNewWindow2(Sender: TObject; var ppDisp: IDispatch;
  var Cancel: WordBool);
begin
  //炵tH[쐬
  MainForm.CreateMDIChild('Mozilla',strURL);
  //irQ[g̃LZ
  Cancel := True;

end;


procedure Tfrm_MZ.TWeb_MZProgressChange(Sender: TObject; Progress,
  ProgressMax: Integer);
//vOXo[̕\
var
	tmpInt:Byte;
begin
 //ǂݍ݋\
 self.Tag:=Progress;
 if Progress<>0 then begin
    MainForm.Progressbar1.Position:= Progress*100
                 div ProgressMax;
 end;

 //Sēǂݍ񂾂珉
  tmpInt:=MainForm.Progressbar1.Position;
  if tmpInt=100 then begin
    MainForm.Progressbar1.Position:=0;
    MainForm.StopCtrl.Enabled := False;
  end else begin
    MainForm.StopCtrl.Enabled := True;
  end;
end;

procedure Tfrm_MZ.TWeb_MZStatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  //}EXǂĂ邩`FbN
  MainForm.StatusBar1.Panels.Items[0].Text:=text;
  strURL:=text;
end;

procedure Tfrm_MZ.TWeb_MZTitleChange(Sender: TObject;
  const Text: WideString);
begin
  //^Cgς̏
  self.Caption:=text;
  MainForm.txtAddress.Text:=TWeb_mz.LocationURL;
end;


procedure Tfrm_MZ.TWeb_MZCommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
begin
  With Main.MainForm do begin
  	case Command of
  	  CSC_NAVIGATEBACK: BackCtrl.Enabled := Enable;
  	  CSC_NAVIGATEFORWARD: FrwrdCtrl.Enabled := Enable;
   	end;
    ReLoadCtrl.Enabled:=True;
    SubChange(tmpBool);
  end;

end;

end.
