unit Option;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SHBFFEX, Buttons ,IniFiles, ComCtrls, ExtCtrls;

type
  Tfrm_Option = class(TForm)
    selectFolder: TSHBrowseForFolderEx;
    TreeView1: TTreeView;
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    PageCTL: TPageControl;
    TabSheet1: TTabSheet;
    txtMozPath: TEdit;
    chkMoz: TCheckBox;
    BitBtn1: TBitBtn;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    chkWin1: TCheckBox;
    chkWin2: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure chkMozClick(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure chkWin1Click(Sender: TObject);
    procedure chkWin2Click(Sender: TObject);
    procedure ReadIni();
	private
    { Private 錾 }
    strPath:string;
  public
    { Public 錾 }
  end;

var
  frm_Option: Tfrm_Option;

implementation
uses Main;

{$R *.DFM}

procedure Tfrm_Option.ReadIni();
var
	WinIni: TIniFile;
begin
  //IniFileIvVǂݍ
		WinIni := TIniFile.Create(strPath+'config.ini');
    //Mozillagp邩ǂ
      if Winini.ReadInteger('Option_Main','Mozilla',0)=0 then
      begin
        //gp
      	chkMoz.Checked:=False;
      end else begin
        //gpȂ
      	chkMoz.Checked:=True;
      end;
      chkMoz.OnClick(chkMoz);
    	//MozillâpX
  			txtMozPath.text:=Winini.ReadString('Option_Main','MozPath','');
    //VKEBhE
      //ubN}[N
      if Winini.ReadInteger('Option_Window','BookMark',0)=0 then
      begin
        //gp
      	chkWin1.Checked:=False;
      end else begin
        //gpȂ
      	chkWin1.Checked:=True;
      end;
      chkWin1.OnClick(chkWin1);
      //Bar
      if Winini.ReadInteger('Option_Window','AddressBar',0)=0 then
      begin
        //gp
      	chkWin2.Checked:=False;
      end else begin
        //gpȂ
      	chkWin2.Checked:=True;
      end;
      chkWin2.OnClick(chkWin2);
  //iniFile
    WinIni.Free;
end;

procedure Tfrm_Option.FormCreate(Sender: TObject);
var
  SheetIndex:Byte;
begin
  //JgpX擾
	strPath:=Main.MainForm.MyPath;

  //IniFileIvVǂݍ
  ReadIni();

	//^u\ɂ
	for SheetIndex:= 1 to 2 do begin
		TTabSheet(FindComponent('TabSheet' + IntToStr(SheetIndex)))
					.TabVisible:=False;
  end;
  //ԏ̃^uI
  TreeView1.TopItem.Selected:=True;
end;

procedure Tfrm_Option.BitBtn1Click(Sender: TObject);
begin
  //tH_Q
	if selectFolder.Execute then
  		txtMozPath.Text:=selectFolder.FolderName;
end;

//OK̏
procedure Tfrm_Option.Button1Click(Sender: TObject);
var
  WinIni: TIniFile;
begin

  //IniFileɃIvV
		WinIni := TIniFile.Create(Main.MainForm.MyPath+'config.ini');
    //Mozilla̎gp
  		WinIni.WriteString('Option_Main','MozPath',txtMozPath.text);
    	WinIni.WriteInteger('Option_Main','Mozilla',chkMoz.tag);
    //VKŊJEChE
    	WinIni.WriteInteger('Option_Window','BookMark',chkWin1.Tag);
			WinIni.WriteInteger('Option_Window','AddressBar',chkWin2.Tag);
  	WinIni.Free;


  //tH[
  	self.Close;  
end;



procedure Tfrm_Option.Button2Click(Sender: TObject);
begin
	self.Close;
end;

procedure Tfrm_Option.chkMozClick(Sender: TObject);
begin
	if chkMoz.Checked=True then
  begin
    chkMoz.tag:=1;
  	txtMozPath.Enabled:=True;
    txtMozPath.Color:=clCaptionText;
    BitBtn1.Enabled:=True;
    MainForm.Moz_item.Enabled:=True;
  end else begin
  	txtMozPath.Enabled:=False;
    txtMozPath.Color:=clInactiveBorder;
    BitBtn1.Enabled:=False;
    chkMoz.tag:=0;
    MainForm.Moz_item.Enabled:=False;
  end;
end;

procedure Tfrm_Option.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
 //IvV؂ւ
	if Node.Text='S' then
  begin
		TabSheet1.Show;
  end else
  if Node.Text='EBhE' then
  begin
  	TabSheet2.Show;
  end;
end;

procedure Tfrm_Option.chkWin1Click(Sender: TObject);
begin
	if chkWin1.Checked then begin
  	chkWin1.Tag:=1;
  end else begin
  	chkWin1.Tag:=0;
  end;
end;

procedure Tfrm_Option.chkWin2Click(Sender: TObject);
begin
	if chkWin2.Checked then begin
  	chkWin2.tag:=1;
  end else begin
  	chkWin2.Tag:=0;
  end;
end;

end.
