unit childIE;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, ComCtrls,
  ToolWin,SysUtils ,ImgList, OleCtrls, SHDocVw,main;

type
  Tfrm_IE = class(TForm)
    TWeb_IE: TWebBrowser;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TWeb_IENewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure TWeb_IEProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure TWeb_IEStatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure TWeb_IETitleChange(Sender: TObject; const Text: WideString);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TWeb_IECommandStateChange(Sender: TObject; Command: Integer;
      Enable: WordBool);
    procedure SubChange(Enable:WordBool);
    procedure AppOnDeactivate(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
  private
    { Private 錾 }
    strURL: string;
    blBack	: WordBool;
    blFrwrd	: WordBool;
    blStop 	: WordBool;
    blReLoad: WordBool;
    tmpBool	:	WordBool;

  public
    { Public 錾 }
    intMojiSize: Byte;
  end;

implementation
procedure MojiSizeChange(i:byte);
begin
	with MainForm do
  begin
  	mnuSize_Max.Checked:=False;
  	mnuSize_Large.Checked:=False;
  	mnuSize_Middle.Checked:=False;
  	mnuSize_Small.Checked:=False;
  	mnuSize_Min.Checked:=False;

		case  i  of
   		0: mnuSize_Min.Checked:=True;
   		1: mnuSize_Small.Checked:=True;
   		2: mnuSize_Middle.Checked:=True;
   		3: mnuSize_Large.Checked:=True;
   		4: mnuSize_Max.Checked:=True;
  	end;
  end;
end;

{$R *.DFM}
procedure Tfrm_IE.SubChange(Enable:WordBool);
begin
  //߂Eiނ̏󋵂L
	with MainForm do begin
  	if Enable=True then begin
  		Tfrm_IE(ActiveMDIChild).blBack:=BackCtrl.Enabled;
  		Tfrm_IE(ActiveMDIChild).blFrwrd:=FrwrdCtrl.Enabled;
    	Tfrm_IE(ActiveMDIChild).blReLoad:=ReLoadCtrl.Enabled;
  		Tfrm_IE(ActiveMDIChild).blStop:=StopCtrl.Enabled;
    end else begin
  		ProgressBar1.Position:=0;
		  txtAddress.Text:='';
		  StatusBar1.Panels.Items[0].Text:='';

		  //c[{^
				BackCtrl.Enabled:=False;
				FrwrdCtrl.Enabled:=False;
				ReLoadCtrl.Enabled:=False;
				StopCtrl.Enabled:=False;
		end;
  end;
end;

procedure Tfrm_IE.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //lɖ߂
  tmpBool:=False;
  SubChange(False);
  	//OtĕۑFalse
  		MainForm.mnuFile_SaveAs.Enabled:=False;
  	//ҏWj[False
  		MainForm.mnuEdit_slrAll.Enabled:=False;
    	MainForm.mnuEdit_Copy.Enabled:=False;
  	//TCYFalse
  		MainForm.mnuShow_Size.Enabled:=False;
  //
  Action := caFree;

end;

procedure Tfrm_IE.TWeb_IENewWindow2(Sender: TObject; var ppDisp: IDispatch; var Cancel: WordBool);
begin
  //炵tH[쐬
  MainForm.CreateMDIChild('Internet Explorer',strURL);
  //irQ[g̃LZ
  Cancel := True;
end;

procedure Tfrm_IE.TWeb_IEProgressChange(Sender: TObject; Progress,
  ProgressMax: Integer);
//vOXo[̕\
begin
 //ǂݍ݋\
 self.tag:=Progress;
 if ProgressMax<>0 then begin
    MainForm.Progressbar1.Position:= Progress*100
                 div ProgressMax;
 end else begin

    //Sēǂݍ񂾂珉
    if Progress=ProgressMax then begin
      MainForm.Progressbar1.Position:=0;
    end;
 end;

end;

procedure Tfrm_IE.TWeb_IEStatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  //}EXǂĂ邩`FbN
  MainForm.StatusBar1.Panels.Items[0].Text:=text;
  strURL:=text;
end;

procedure Tfrm_IE.TWeb_IETitleChange(Sender: TObject;
  const Text: WideString);
begin
  //^Cgς̏
  self.Caption:=text;
  MainForm.txtAddress.Text:=TWeb_ie.LocationURL;
end;

procedure Tfrm_IE.FormResize(Sender: TObject);
begin
  //TCY̒`
  TWeb_ie.Width:=Self.Width-8;
  TWeb_ie.Height:=Self.Height-28;
end;

procedure Tfrm_IE.FormCreate(Sender: TObject);
begin
  self.intMojiSize:=MainForm.intMojiSize;
  self.Visible:=True;
  //߂Eiނ̏󋵂L
 	With Main.MainForm do begin
  	blBack:=BackCtrl.Enabled;
  	blFrwrd:=FrwrdCtrl.Enabled;
  	blStop:=StopCtrl.Enabled;
  end;
  tmpBool:=True;
  self.OnResize(Sender);
end;

procedure Tfrm_IE.FormActivate(Sender: TObject);
begin
  With Main.MainForm do begin
  	//ANeBȕ
  		//URL̕ύX
  		txtAddress.Text:=TWeb_ie.LocationURL;
  	//vOXo[̕ύX
  		ProgressBar1.Position:=self.Tag;

  //߂Eiނ̏󋵂ύX
 	 	BackCtrl.Enabled:=Tfrm_IE(ActiveMDIChild).blBack;
  	FrwrdCtrl.Enabled:=Tfrm_IE(ActiveMDIChild).blFrwrd;
  	StopCtrl.Enabled:=Tfrm_IE(ActiveMDIChild).blStop;
    ReLoadCtrl.Enabled:=Tfrm_IE(ActiveMDIChild).blReLoad;
  end;
  //OtĕۑTrue
  	MainForm.mnuFile_SaveAs.Enabled:=True;
  //ҏWj[True
  	MainForm.mnuEdit_slrAll.Enabled:=True;
    MainForm.mnuEdit_Copy.Enabled:=True;
	//TCY̕ύX
	  MojiSizeChange(self.intMojiSize);
  //TCYTrue
  	MainForm.mnuShow_Size.Enabled:=True;
end;

procedure Tfrm_IE.AppOnDeactivate(Sender: TObject);
begin
	beep;
end;

procedure Tfrm_IE.TWeb_IECommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
begin
  With Main.MainForm do begin
  	case Command of
  	  CSC_NAVIGATEBACK: BackCtrl.Enabled := Enable;
  	  CSC_NAVIGATEFORWARD: FrwrdCtrl.Enabled := Enable;
   	end;
    ReLoadCtrl.Enabled:=True;
  //߂Eiނ̏󋵂L
  	SubChange(tmpBool);
  end;
end;

procedure Tfrm_IE.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  //TCY̒`
  TWeb_ie.Width:=Self.Width-10;
  TWeb_ie.Height:=Self.Height-30;
end;

end.
